#if 0 

    Copyright (c) 1991 SGI   All Rights Reserved
    THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SGI
    The copyright notice above does not evidence any
    actual or intended publication of such source code,
    and is an unpublished work by Silicon Graphics, Inc.
    This material contains CONFIDENTIAL INFORMATION that
    is the property of Silicon Graphics, Inc. Any use,
    duplication or disclosure not specifically authorized
    by Silicon Graphics is strictly prohibited.
    
    RESTRICTED RIGHTS LEGEND:
    
    Use, duplication or disclosure by the Government is
    subject to restrictions as set forth in subdivision
    (c)(1)(ii) of the Rights in Technical Data and Computer
    Software clause at DFARS 52.227-7013, and/or in similar
    or successor clauses in the FAR, DOD or NASA FAR
    Supplement.  Unpublished- rights reserved under the
    Copyright Laws of the United States.  Contractor is
    SILICON GRAPHICS, INC., 2011 N. Shoreline Blvd.,
    Mountain View, CA 94039-7311

#endif
/*
    ilCombineImg is derived from ilPolyadicImg and performs blending
    of two ilImages, using an Roi.
*/

#ifndef _ilCombineImg_h_
#define _ilCombineImg_h_

#include <il/ilPolyadicImg.h>
class ilRoi;

class ilCombineImg : public ilPolyadicImg {
public:
    iflClassListDeclare
    ~ilCombineImg();
    // external api: begin
    ilCombineImg(ilImage* fore=NULL, ilImage* bkgd=NULL, ilRoi* roi=NULL, 
		 int xoffset=0, int yoffset=0, int zoffset=0);

    void setRoi(ilRoi* roi, int xoffset=0, int yoffset=0, int zoffset=0);
    ilRoi* getRoi();
    void getRoiOffset(int& xoffset, int& yoffset, int& zoffset)
    	{ xoffset = roiOffset.x; yoffset = roiOffset.y; zoffset = roiOffset.z; }
    // external api: end

protected:
    virtual void resetOp();
    virtual ilStatus prepareRequest(ilMpCacheRequest* req);
    virtual ilMpCacheRequest* getMpRequest(ilMpManager* parent, 
					   int x, int y, int z, int c, 
					   int mode=ilLMread);
    virtual ilStatus calcPage(void** inBuf, int numIn, void* outBuf, 
			      ilMpCacheRequest& req);

private:
    iflXYZint roiOffset;
};
#endif
